{
 HEAP.PAS

 Shows, how to allocate memory.
 Here we create a virtual screen and copy it to the screen

}

program 'Virtual Screen';
uses flib,tios;

import macros;

var virtual_screen_address: pointer;
    buffer_pointer: pointer;
    screen: pointer;
    i: word;
end;

procedure copy_virtual_screen();
begin
screen:=tios::main_lcd;
buffer_pointer:=virtual_screen_address;
{
 Copy the screen
 Screensize = 3840      -> 3840 / 4 - 1 = 959
}
for i:=0 to 959 do begin
  screen^:=buffer_pointer^;
  inc(screen,4);
  inc(buffer_pointer,4);
end;
end;

procedure fill_virtual_screen(x: longint);
{ Fills the virtual screen }
begin
buffer_pointer:=virtual_screen_address;
for i:=0 to 959 do begin
 buffer_pointer^:=x;
 inc(buffer_pointer,4);
end;
end;

begin
 {
  Allocate memory for the virtual screen
  screen_size := 240 * 128 / 8 = 3840;
  Division by 8, because each bit is a pixel!
 }
 virtual_screen_address:=paslib::getmem(3840);

 fill_virtual_screen($FFFFFFFF);
 copy_virtual_screen();

 { Black screen ( BUSY indicator is white, from FLIB::IDLE_LOOP ) }
 flib::idle_loop();

 {
  Here we haven't to free the memory.
  2 reasons why:
    Fargo Pascal does it at the end
    Code is getting smaller
 }
end;
