;******************************************************************************
; 			FARGO PASCAL LIBRARY
;------------------------------------------------------------------------------
; The library, which includes the most required procedures
; and the exception handlers for Fargo Pascal
;
; Documentation: DOC\PASLIB.DOC
;
; released by MXM Projects
; http://start.at/mxm
;
; created by MXM-TriX
; alexander.grutsch.htlr@schulen.vol.at
;
; Version		0.6
; for 			Fargo Pascal	V0.8.12
;			Fargo II	0.2.6
; Last update   	20.06.1998
;
; I generally use C/C++ for prototypes of a function, for better
; understanding etc.
;******************************************************************************

	include "tios.h"
        include "gray4lib.h"
	include "flib.h"
        xdef _library
        xdef paslib@0000
	xdef paslib@0001
        xdef paslib@0002
        xdef paslib@0003
        xdef paslib@0004
        xdef paslib@0005
	xdef paslib@0006
	xdef paslib@0007
	xdef paslib@0008
	xdef paslib@0009
	xdef paslib@000a

;------------------------------------------------------------------------------
; void put_sprite ( void *spr_tbl, int sprnr, int x_coor, int y_coor );
; spr_table		-> a0
; sprnr			-> d2
; x_coor		-> d0
; y_coor		-> d1
;
; This procedure puts a sprite to the screen, by using the 'MOVE'.
; Routine from Jimmy Mardell.
; Gray4lib has to be active!
;------------------------------------------------------------------------------

paslib@0000:
put_sprite:

 movem.l d0-d3/a0-a2,-(a7)
 sub.w   #1,d2
 lsl.l   #6,d2
 adda.l  d2,a0
 lsl.w   #1,d1
 move.l  d1,d2
 lsl.w   #4,d2
 sub.w   d1,d2
 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 add.w   d0,d2
 and.b   #$0F,d1
 sub.b   #16,d1
 neg     d1
 moveq   #15,d0
 move.l  gray4lib::plane1,a1
 move.l  gray4lib::plane0,a2
 adda.l  d2,a1
 adda.l  d2,a2
PS_PutRow:
 clr.l   d2
 move.w  (a0)+,d2
 lsl.l   d1,d2
 eor.l   d2,(a1)
; EOR is faster and secondly better for sprites
 clr.l   d2
 move.w  (a0)+,d2
 lsl.l   d1,d2
 eor.l   d2,(a2)
 lea     30(a1),a1
 lea     30(a2),a2
 dbra    d0,PS_PutRow
 movem.l (a7)+,d0-d3/a0-a2
 rts

;------------------------------------------------------------------------------
; void put_sprite_move ( void *spr_tbl, int sprnr, int x_coor, int y_coor );
; spr_table		-> a0
; sprnr			-> d2
; x_coor		-> d0
; y_coor		-> d1
;
; This procedure puts a sprite to the screen, by using the 'MOVE'.
; Routine from Jimmy Mardell.
; Gray4lib has to be active!
;------------------------------------------------------------------------------

paslib@0001:
put_sprite_move:

 movem.l d0-d3/a0-a2,-(a7)
 sub.w   #1,d2
 lsl.l   #6,d2
 adda.l  d2,a0
 lsl.w   #1,d1
 move.l  d1,d2
 lsl.w   #4,d2
 sub.w   d1,d2
 move.b  d0,d1
 and.w   #$FFF0,d0
 lsr.b   #3,d0
 add.w   d0,d2
 and.b   #$0F,d1
 sub.b   #16,d1
 neg     d1
 moveq   #15,d0
 move.l  gray4lib::plane1,a1
 move.l  gray4lib::plane0,a2
 adda.l  d2,a1
 adda.l  d2,a2
 move.l  #$FFFF0000,d3
 rol.l   d1,d3
PS_PutRow_move:
 clr.l   d2
 move.w  (a0)+,d2
 lsl.l   d1,d2
 and.l   d3,(a1)
 or.l    d2,(a1)
 clr.l   d2
 move.w  (a0)+,d2
 lsl.l   d1,d2
 and.l   d3,(a2)
 or.l    d2,(a2)
 lea     30(a1),a1
 lea     30(a2),a2
 dbra    d0,PS_PutRow_move
 movem.l (a7)+,d0-d3/a0-a2
 rts


;------------------------------------------------------------------------------
; long pascal_mod ( long par1, long par2 );
; par1		-> stack
; par2		-> stack
; return	-> (a4)
;
; This is the MOD function, which
;------------------------------------------------------------------------------
paslib@0002:
__pascal_mod:
; Idea from Rafael H. Padilla V.
  movem.l d0-d1,-(a7)
  move.l (sp)+,d0
  move.l (sp)+,d1

; Division by Zero will terminate the program!
; This part is detected by the internal exceptionhandlers, so here isn't any
; test necessary

  divs.l d1,d0
  swap d0
  move.l d0,(a4)
  movem.l (a7)+,d0-d1
  rts

;*****************************************************************************
; 		INTERNAL PROCEDURES FROM FARGO PASCAL
;-----------------------------------------------------------------------------
; This routines aren't exported to Fargo Pascal, because for beginners they
; are a very critical section and wrong handling can cause a TI92 crash!
; Look at PASLIB.DOC for some infos
;*****************************************************************************

;------------------------------------------------------------------------------
; void ShowError ();
; Display an errorstring[__exception_code] and waits for a key
;------------------------------------------------------------------------------

ShowError:

        jsr flib::zap_screen
	move.w #1,-(a7)
	jsr tios::FontSetSys
	lea 2(a7),a7

	move.w #4,-(a7)
	pea __exception_show_error(PC)
	move.w #53,-(a7)
	clr.w -(a7)
	jsr tios::DrawStrXY
	lea 10(a7),a7

	move.w __exception_code,-(a7)
	move.l __exception_at,-(a7)
	pea __exception_format_string(PC)
	pea __exception_output_string(PC)
	jsr tios::sprintf
	lea 14(a7),a7

	move.w #4,-(a7)
	pea __exception_output_string(PC)
	move.w #63,-(a7)
	clr.w -(a7)
	jsr tios::DrawStrXY
	lea 10(a7),a7


	move.w __exception_code,d0
	sub.w #1,d0
	lea exception_table(PC),a0
	move.l a0,a1
	lsl.w #2,d0
	move.l 0(a0,d0.w),a0
	adda.l a0,a1
	
	move.w #4,-(a7)
	move.l a1,-(a7)
	move.w #73,-(a7)
	clr.w -(a7)
	jsr tios::DrawStrXY
	lea 10(a7),a7
	
	jsr flib::idle_loop
	rts


;------------------------------------------------------------------------------
; void register_pascal_program (void *stack_pointer, void *end_of_program);
; stack_pointer		-> a6
; end_of_program	-> a5
;
; This section is for initializing a pascal program
;------------------------------------------------------------------------------

paslib@0003:
register_pascal_program:
  move.l a6,__pascal_stack
  move.l a5,__pascal_proc_exception
  clr.w __exception_code

  bsr DisableTry  			; Disable the 'TRY'
  bsr InitMemoryManager			; Heap-Manager initializing sequence

; Install exception handlers
  move.w #$700,d0
  trap #1
  bclr.b #2,$600001
  move.w #47,d1
  move.l #0,a0
  lea exception_original_addresses,a1
_copy_original_addresses:
  move.l (a0)+,(a1)+
  dbra.w d1,_copy_original_addresses

; Install own exception handlers

  move.l #_div_0_exception,($14)	; Division by Zero
  move.l #_address_exception,($C)	; Address error
  move.l #_illegal_exception,($10)	; Illegal instruction
  move.l #_privilege_exception,($20)	; Privilege violation
  move.l #_line1010_exception,($28)	; Line 1010 emulator
  move.l #_line1111_exception,($2C)	; Line 1111 emulator

  bset.b #2,$600001
  trap #1
  rts

;------------------------------------------------------------------------------
; void handle_pascal_exceptions ();
;
; This section is always called to terminate the program and also to handle
; exception, when an interrupt happen.
;------------------------------------------------------------------------------

paslib@0004:
__handle_pascal_exceptions:
; In	Nothing
; Out	Nothing, program will terminate!
; This routine is called to terminate the program and to restore the TI92 state

  bsr DisableMemoryManager
  bsr unregister_pascal_program

  move.w __exception_code,d1

  tst.w d1
  beq _no_exception
  
  bsr ShowError
  bra _no_exception

_no_exception:

  move.l __pascal_stack,a6
  lea 996(a6),a6

; Back to the TI92
  rts

;------------------------------------------------------------------------------
; void unregister_pascal_program ();
;
; This section deinstall all exception handlers, ...
;------------------------------------------------------------------------------

paslib@0005:
unregister_pascal_program:
; Unregister the pascalprogram and deinstall all handlers

; Deinstall all exception handlers

  move.w #$700,d0
  trap #1
  bclr.b #2,$600001
  
  lea exception_original_addresses,a0
  move.w #47,d1
  move.l #0,a1

_restore_original_ints:
  move.l (a0)+,(a1)+
  dbra.w d1,_restore_original_ints
  
  bset.b #2,$600001
  trap #1

  move.l __pascal_stack,a6
  lea 996(a6),a6
  rts

;------------------------------------------------------------------------------
; void EnableTry ();
;
; This procedure enables the TRY instruction from Fargo Pascal. This procedure
; sets a flag for the exceptionhandlers, that the return address is the
; instruction after the exception.
;------------------------------------------------------------------------------
paslib@0006:
EnableTry:
	move.w #1,Try_enabled
	rts

;------------------------------------------------------------------------------
; void DisableTry ();
;
; This procedure disables the TRY instruction
;------------------------------------------------------------------------------
paslib@0007:
DisableTry:
	clr.w Try_enabled
	clr.w __exception_code
	rts

;*****************************************************************************
;			EXCEPTIONHANDLERS FROM FARGO PASCAL
;-----------------------------------------------------------------------------
; This part is a critical area. If you are a beginner, don't modify anything,
; else we take no liabality, if your TI92 crashs
; 
; Here are all interrupthandlers and some internal procedures!
;
; Exceptionprincip:
; When an exception happens, then this procedures restore the state of the 
; TI92. It's a very simple technique. We just modify the stack and return of
; the interrupt. Since in interrupts we can't access any text functions, any
; Fargo Pascal program requires a exception section ( this could be probably
; programable in future ).
;*****************************************************************************


_div_0_exception:

; This is the routine for the division by zero trap.

  move.w #1,__exception_code
  bra restore_ti92_state

_address_exception:
  move.w #2,__exception_code
  bra restore_ti92_state

_privilege_exception:
  move.w #3,__exception_code
  bra restore_ti92_state

_chkv_exception:
  move.w #4,__exception_code
  bra restore_ti92_state

_trapv_exception:
  move.w #5,__exception_code
  bra restore_ti92_state

_line1010_exception:
  move.w #6,__exception_code
  bra restore_ti92_state

_line1111_exception:
  move.w #7,__exception_code
  bra restore_ti92_state

_illegal_exception:
  move.w #8,__exception_code
  bra restore_ti92_state

_other_exceptions:

; Here are other exceptions, but they are just to avoid the crash of the calc

  move.w #9,__exception_code

; Other exceptions for the future

; This is the real critical section of all exception handlers!

restore_ti92_state:
	
; Call the exception routine from the pascalprogram
; Fargo Pascal supports the 'TRY' instruction, but it seems, that somewhere
; is a bug, when Try_enabled is TRUE.

;	tst.w Try_enabled
;	bne try_is_enabled
	move.l 2(a7),__exception_at
	move.l __pascal_proc_exception,2(a7)
;try_is_enabled:
	rte
	

;******************************************************************************
;			MEMORYHANDLING SYSTEM
;------------------------------------------------------------------------------
;
; Here is the memoryhandling of Fargo Pascal memory
;------------------------------------------------------------------------------


;------------------------------------------------------------------------------
; void InitMemoryManager ()
;
; This routine is called from the registerprogram. It initializes the memory
; for the own table.
;------------------------------------------------------------------------------

InitMemoryManager:

	movem.l d0-d7/a0-a6,-(a7)

	lea memsystem_table,a0

	move.w #24,d0
_clear_table:
	clr.w (a0)+
	dbra.w d0,_clear_table

	movem.l (a7)+,d0-d7/a0-a6
	rts

;------------------------------------------------------------------------------
; void DisableMemoryManager ();
;
; Shut down the memory manager
;------------------------------------------------------------------------------
DisableMemoryManager:
	movem.l d0-d7/a0-a6,-(a7)

	lea memsystem_table,a0
	move.w #24,d0

__free_memory_loop:
	move.w (a0)+,d1
	tst.w d1
	beq _next_memory_loop
	movem.l d0-d7/a0-a6,-(a7)
	move.w d1,-(a7)
	jsr tios::HeapFree
	lea 2(a7),a7
	movem.l (a7)+,d0-d7/a0-a6
_next_memory_loop:
	dbra.w d0,__free_memory_loop	

	movem.l (a7)+,d0-d7/a0-a6
	rts

;------------------------------------------------------------------------------
; void *getmem (long size);
; size		-> d0
; return	-> (a4)
;
; Allocates memory
;------------------------------------------------------------------------------

paslib@0009:
getmem:
	move.l d0,malloc_size
	movem.l d0-d7/a0-a6,-(a7)

	lea memsystem_table,a0

	move.w #24,d0

_find_entry:
	tst.w (a0)
	beq __founded_entry
	lea 2(a0),a0
	dbra.w d0,_find_entry

	movem.l (a7)+,d0-d7/a0-a6
	clr.l (a4)
	rts

__founded_entry:
	movem.l a0,-(a7)
	move.l malloc_size,-(a7)
	jsr tios::HeapAlloc
	lea 4(a7),a7
	movem.l (a7)+,a0
	move.w d0,(a0)
	tios::DEREF d0,a0
	move.l a0,(a4)
	movem.l (a7)+,d0-d7/a0-a6
	rts

;------------------------------------------------------------------------------
; void freemem (void *free_ptr);
; free_ptr	-> D0
;
; Frees the memory, used by FREE_PTR
;------------------------------------------------------------------------------
paslib@000a:
freemem:
	movem.l d0-d7/a0-a6,-(a7)
	tios::DEREF d0,a0
	cmpa.l #0,a0
	beq __done_freemem

	lea memsystem_table,a1
	move.w #24,d0

_find_handle:
	move.w (a1)+,d3
	move.w d3,d4
        beq __freemem_loop      
	tios::DEREF d3,a3
	cmpa.l a3,a0
	beq __free_mem
__freemem_loop:
	dbra.w d0,_find_handle
__done_freemem:
	movem.l (a7)+,d0-d7/a0-a6
	rts

__free_mem:
	lea -2(a1),a1
	clr.w (a1)
	move.w d4,-(a7)
	jsr tios::HeapFree
	lea 2(a7),a7
	bra __done_freemem

;******************************************************************************
;				VARIABLES
;------------------------------------------------------------------------------

malloc_size			dc.l 0

__pascal_proc_exception		dc.l 0
__pascal_stack                  dc.l 0

paslib@0008:
__exception_code		dc.w 0
__exception_at			dc.l 0

Try_enabled			dc.w 0

exception_table		dc.l (__division_exception-exception_table),
			dc.l (__address_exception-exception_table),
			dc.l (__privilege_exception-exception_table),
			dc.l (__chkv_exception-exception_table),
			dc.l (__trapv_exception-exception_table),
			dc.l (__line1010_exception-exception_table),
			dc.l (__line1111_exception-exception_table),
			dc.l (__illegal_exception-exception_table),
			dc.l (__unknown_exception-exception_table)

__exception_show_error		dc.b "Fargo Pascal exception",0
__exception_format_string	dc.b "at %08lX, exceptioncode %d",0
__exception_output_string	dc.b "                                      ",0

__division_exception            dc.b "Division by Zero exception!",0
; Code	1

__address_exception		dc.b "Address Error exception!",0
; Code	2

__privilege_exception		dc.b "Privilige violation exception!",0
; Code	3

__chkv_exception		dc.b "CHKV exception!",0
; Code	4

__trapv_exception		dc.b "TRAPV exception!",0
; Code 5

__line1010_exception		dc.b "Line 1010 exception!",0
; Code 6

__line1111_exception		dc.b "Line 1111 exception!",0
; Code 7

__illegal_exception		dc.b "Illegal instruction",0
; Code 8

__unknown_exception		dc.b "Unknown exception code!",0
; Code 9


_library                        dc.b "paslib",0

	BSS

exception_original_addresses	ds.l 48
memsystem_table			ds.w 25

        END
